#include "StdAfx.h"
#include "UIStickerElement.h"
#include "ChatMainView.h"

#define DEF_CHAT_MSG_BUBBLE_STICKER_TOP_Y           (15)
#define DEF_CHAT_MSG_BUBBLE_STICKER_USERNAME_TOP_Y  (4)

#define DEF_CHAT_MSG_PLAIN_STICKER_TOP_X (10)
#define DEF_CHAT_MSG_PLAIN_STICKER_TOP_Y (9)


UIStickerElement::UIStickerElement( CChatItem* pChatItem, IUIElementResouce* pResouce) : UIElement(pChatItem, pResouce)
{
	m_rcReSendImg.SetRectEmpty();
	m_rcSendCount.SetRectEmpty();
	m_rcSticker.SetRectEmpty();
}

UIStickerElement::~UIStickerElement( void )
{
	m_rcReSendImg.SetRectEmpty();
	m_rcSendCount.SetRectEmpty();
}

BOOL UIStickerElement::Draw( Graphics *graph )
{
	CPoint ptZero(0, 0);
	CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	CRect rcClient = m_pResouce->GetViewRect();
	
	ImageAttributes ImgAttr;


	CRect rcView = m_pResouce->GetViewRect();

	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		if (m_dwFlags & DEF_CHAT_MSG_DATE)
		{
			DrawDate(graph);
		}
		if ((m_dwFlags & DEF_CHAT_MSG_USERNAME) && !(m_dwFlags & DEF_CHAT_MSG_ISMINE))
		{
			DrawUserName(graph);
			DrawUserImage(graph);
			DrawTime(graph);
		}
		else
		{
			if (m_dwFlags & DEF_CHAT_MSG_TIME)
			{	
				DrawTime(graph);
			}
		}

		CChatStickerItem* pStickerItem = dynamic_cast<CChatStickerItem*>(m_pChatItem);
		if (pStickerItem == NULL)
		{
			return FALSE;
		}
		Image* pImage = m_pResouce->GetStickerImageByID(pStickerItem->GetChatStickerID());
		if (pImage == NULL)
		{
			return FALSE;
		}
		CRect rcSticker = m_rcSticker;
		rcSticker.OffsetRect(ptOffset);
// 		Pen *pen = new Pen(Color(00,0xFF,0));
// 		graph->DrawRectangle(pen,rcSticker.left,rcSticker.top,rcSticker.Width(),rcSticker.Height());

		DrawImageToDest(graph, pImage, &rcClient, &rcSticker, &ImgAttr);
		if (m_dwFlags & DEF_CHAT_MSG_RESEND)
		{
			if (pStickerItem && m_pResouce)
			{
				CRect rcReSendImg = m_rcReSendImg;
				rcReSendImg.OffsetRect(ptOffset);
				DrawRetryStatus(graph,rcReSendImg);
			}
		}
	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		//if (m_dwFlags & DEF_CHAT_MSG_USERNAME)
		//{
			DrawUserName(graph);
			DrawUserImage(graph);
		//}

		DrawTime(graph);

		CChatStickerItem* pStickerItem = dynamic_cast<CChatStickerItem*>(m_pChatItem);
		if (pStickerItem == NULL)
		{
			return FALSE;
		}
		Image* pImage = m_pResouce->GetStickerImageByID(pStickerItem->GetChatStickerID());
		if (pImage == NULL)
		{
			return FALSE;
		}
		CRect rcSticker = m_rcSticker;
		rcSticker.OffsetRect(ptOffset);
		DrawImageToDest(graph, pImage, &rcClient, &rcSticker, &ImgAttr);

		if (m_dwFlags & DEF_CHAT_MSG_ISMINE && m_pChatItem->IsFailedMsg())
		{
			//CPoint ptZero(0, 0);
			//CPoint ptOffset = ptZero - m_pResouce->GetOffSetPoint();
			CRect rcReSend = m_rcReSendImg;
			rcReSend.OffsetRect(ptOffset);
			DrawRetryStatus(graph,rcReSend);

//  			CRect rcSendCount = m_rcSendCount;
//  			rcSendCount.OffsetRect(ptOffset);
//  			DrawChatText(graph, m_pChatItem->GetFailCount(), 
//  				&rcView, &rcSendCount, 
//  				g_defaultFontFaceName, (REAL)DEF_SEND_COUNT_FONT_SIZE,
//  				StringAlignmentCenter, FontStyleRegular, m_crReSendCount, FALSE, 0, 0);

// 			CRect rcReSend = m_rcReSendImg;
// 			rcReSend.OffsetRect(ptOffset);
// 
// 			Image* pReSendImageL = m_pResouce->GetSendStatusImage(0);
// 			Image* pReSendImageC = m_pResouce->GetSendStatusImage(1);
// 			Image* pReSendImageR = m_pResouce->GetSendStatusImage(2);
// 
// 			CRect rcImageL(rcReSend.left, rcReSend.top,
// 				rcReSend.left + pReSendImageL->GetWidth(),
// 				rcReSend.top + pReSendImageL->GetHeight());
// 
// 			CRect rcImageC(rcImageL.right, rcReSend.top,
// 				rcImageL.right + 2,
// 				rcReSend.top + pReSendImageC->GetHeight());
// 
// 			CRect rcImageR(rcImageC.right, rcReSend.top,
// 				rcImageC.right + pReSendImageL->GetWidth(),
// 				rcReSend.top + pReSendImageL->GetHeight());
// 
// 
// 			DrawImageToDest(graph, pReSendImageL, &rcView, &rcImageL, NULL);
// 			DrawImageToDest(graph, pReSendImageC, &rcView, &rcImageC, NULL);
// 			DrawImageToDest(graph, pReSendImageR, &rcView, &rcImageR, NULL);
// 
// 			CRect rcSendCount = m_rcSendCount;
// 			rcSendCount.OffsetRect(ptOffset);
// 			DrawChatText(graph, m_pChatItem->GetFailCount(), 
// 				&rcView, &rcSendCount, 
// 				g_defaultFontFaceName, (REAL)DEF_SEND_COUNT_FONT_SIZE,
// 				StringAlignmentCenter, FontStyleRegular, m_crReSendCount, FALSE, 0, 0);
		}
	}

	

	//ptOffset = ptZero - m_pResouce->GetOffSetPoint();
	//CRect rcItem = m_rcItem;
	//rcItem.OffsetRect(ptOffset);
	//Pen pen(Color(255, 255, 0, 0));
	//graph->DrawRectangle(&pen, rcItem.left, rcItem.top, rcItem.Width(), rcItem.Height());
	return TRUE;
}

CSize UIStickerElement::CalcSize( const CPoint& ptPos, DWORD dwFlags )
{
	CSize sz(0, 0);
	CPoint ptOffset = ptPos;

	CChatStickerItem* pStickerItem = dynamic_cast<CChatStickerItem*>(m_pChatItem);
	if (pStickerItem == NULL)
	{
		return sz;
	}
	Image* pImage = m_pResouce->GetStickerImageByID(pStickerItem->GetChatStickerID());
	if (pImage == NULL)
	{
		return sz;
	}

	BOOL bUserName = FALSE;
	if (CHAT_BUBBLE == m_pResouce->GetChatDisplayType())
	{
		if (dwFlags & DEF_CHAT_MSG_DATE)
		{
			CalcDateSize(ptPos, sz);
			ptOffset.y += sz.cy;
		}
		if ((dwFlags & DEF_CHAT_MSG_USERNAME) && !(dwFlags & DEF_CHAT_MSG_ISMINE))
		{
			CSize szUserName(0, 0);
			CSize szUserImage(0, 0);
			CalcUserImage(ptOffset, szUserImage);
			CalcUserName(ptOffset, szUserName);
			//if (dwFlags & DEF_CHAT_MSG_TIME)
			//ptOffset.x += sz.cx;
			ptOffset.y += szUserName.cy;
			sz.cx = max(szUserName.cx, sz.cx);
			sz.cy += szUserName.cy;
		}
		else
		{
			
		}

		int nTop = 0;
		if (bUserName)
		{
			nTop = DEF_CHAT_MSG_BUBBLE_TOP_Y;
		}
		else
		{
			nTop = DEF_CHAT_MSG_ITEM_TOP_Y;
		}
		m_rcSticker.top  = nTop;
		if (dwFlags & DEF_CHAT_MSG_ISMINE)
		{
			CRect rcView = m_pResouce->GetViewRect();
			m_rcSticker.left = rcView.right - pImage->GetWidth() - DEF_ITEM_POS_RIGHT_REL_X;
		}
		else
		{
			m_rcSticker.left = DEF_ITEM_POS_LEFT_REL_X + _GetUserImageWidth() + DEF_CHAT_MSG_BUBBLE_ARROR_X;
		}
		m_rcSticker.right = m_rcSticker.left + pImage->GetWidth();
		m_rcSticker.bottom = m_rcSticker.top + pImage->GetHeight();
		m_rcSticker.OffsetRect(ptOffset);

		m_rcBubble = m_rcSticker;
		if (dwFlags & DEF_CHAT_MSG_TIME)
		{
			CSize szTime(0, 0);
			CalcTime(ptOffset, szTime, dwFlags);
			sz.cx = max(szTime.cx, sz.cx);
		}

		if (dwFlags & DEF_CHAT_MSG_ISMINE && m_pChatItem->IsFailedMsg())
		{
			int nWidth = (m_pResouce->GetSendStatusImage(0)->GetWidth() + 
				2 + 
				m_pResouce->GetSendStatusImage(2)->GetWidth());

			if(dwFlags & DEF_CHAT_MSG_ISMINE)
			{
				if(dwFlags & DEF_CHAT_MSG_TIME)
				{
					m_rcReSendImg.right = m_rcTime.left - BUBBLE_STATUS_MARGIN_X;
				}
				else
				{
					m_rcReSendImg.right = m_rcBubble.left - BUBBLE_TIME_MARGIN_X;
				}

				m_rcReSendImg.left = m_rcReSendImg.right - nWidth;

			}
			else
			{
				if(dwFlags & DEF_CHAT_MSG_TIME)
				{
					m_rcReSendImg.left = m_rcTime.right + BUBBLE_STATUS_MARGIN_X;
				}
				else
				{
					m_rcReSendImg.left = m_rcBubble.right + BUBBLE_TIME_MARGIN_X;
				}
				m_rcReSendImg.right = m_rcReSendImg.left + nWidth;
			}



			CSize szTime(0, 0);
 			CRect rtTime(0, 0, 500, 500);
 			REAL fontSize = DEF_SEND_COUNT_FONT_SIZE;
 			RecalcTextRect(m_pResouce->GetCurrentWnd(), m_pChatItem->GetFailCount(),
 				g_defaultFontFaceName, fontSize, FontStyleRegular, rtTime, szTime);

			int yOffset = 1;
			if(dwFlags & DEF_CHAT_MSG_TIME)
			{
				m_rcReSendImg.top = m_rcTime.top - (((int)m_pResouce->GetSendStatusImage(0)->GetHeight() - m_rcTime.Height()) / 2);
				m_rcReSendImg.bottom = m_rcReSendImg.top + m_pResouce->GetSendStatusImage(0)->GetHeight();

			}
			else
			{
				m_rcReSendImg.bottom = m_rcBubble.bottom - BUBBLE_TIME_MARGIN_Y;
				m_rcReSendImg.top = m_rcReSendImg.bottom - szTime.cy;
				yOffset = 2;
			}


// 			m_rcSendCount.left = (m_rcReSendImg.Width() - szTime.cx) / 2 + m_rcReSendImg.left;
// 			m_rcSendCount.right = m_rcSendCount.left + szTime.cx;
// 			m_rcSendCount.top = (m_rcReSendImg.Height() - szTime.cy) / 2 + m_rcReSendImg.top - yOffset;
// 			m_rcSendCount.bottom = m_rcSendCount.top + szTime.cy;
		}

		sz.cy += (pImage->GetHeight() + nTop);
		sz.cx += pImage->GetWidth();

	}
	else if (CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		CSize szUserName(0, 0);
		CSize szUserImage(0, 0);
		CalcUserImage(ptPos,szUserImage);
		CalcUserName(ptPos, szUserName);
		sz.cx = max(sz.cx, szUserName.cx);
		sz.cy += szUserName.cy;
		ptOffset.y += szUserName.cy;
		CSize szTime(0, 0);

		CalcTime(ptOffset, szTime, dwFlags);
		
		int nPlainTop = DEF_CHAT_MSG_PLAIN_STICKER_TOP_Y;
		if (pImage->GetHeight() + nPlainTop > szTime.cy)
		{
			int nHOffSet = pImage->GetHeight() + nPlainTop - szTime.cy;
			
			int nMsgToName_Y = DEF_CHAT_MSG_ITEM_TOP_Y;
			if(!m_rcUserName.IsRectEmpty())
			{
				nMsgToName_Y = PLAIN_MSG_POS_TOP_Y;
			}
			//int nLeft = 

			m_rcSticker.top = m_rcUserName.bottom + nMsgToName_Y;
			m_rcSticker.left  = m_rcUserImage.right + PLAIN_MESSAGE_POS_LEFT_PAD;
			m_rcSticker.bottom = m_rcSticker.top + pImage->GetHeight();
			m_rcSticker.right = m_rcSticker.left + pImage->GetWidth();
		}

		sz.cx = max(m_rcSticker.right, sz.cx);
		sz.cy += m_rcSticker.Height() + nPlainTop;

		if (m_pChatItem->IsFailedMsg())
		{
			int nWidth = (m_pResouce->GetSendStatusImage(0)->GetWidth() + 
				2 + 
				m_pResouce->GetSendStatusImage(2)->GetWidth());

			m_rcReSendImg.left = m_rcUserName.right + PLAIN_STATUS_LEFT_X;
			m_rcReSendImg.right = m_rcReSendImg.left + nWidth;

			m_rcReSendImg.top = m_rcUserName.top;
			m_rcReSendImg.bottom = m_rcReSendImg.top + m_pResouce->GetSendStatusImage(0)->GetHeight();

			CSize szTime(0, 0);
			CRect rtTime(0, 0, 500, 500);
			REAL fontSize = DEF_SEND_COUNT_FONT_SIZE;
			RecalcTextRect(m_pResouce->GetCurrentWnd(), m_pChatItem->GetFailCount(),
				g_defaultFontFaceName, fontSize, FontStyleRegular, rtTime, szTime);

			m_rcSendCount.left = (m_rcReSendImg.Width() - szTime.cx) / 2 + m_rcReSendImg.left;
			m_rcSendCount.right = m_rcSendCount.left + szTime.cx;
			m_rcSendCount.top = (m_rcReSendImg.Height() - szTime.cy) / 2 + m_rcReSendImg.top + 1;
			m_rcSendCount.bottom = m_rcSendCount.top + szTime.cy;
		}
		else
		{
			m_rcSendCount.SetRectEmpty();
			m_rcReSendImg.SetRectEmpty();
		}
	}

	m_rcItem.SetRect(DEF_ITEM_POS_LEFT_REL_X, 0, m_pResouce->GetViewRect().Width() - DEF_ITEM_POS_RIGHT_REL_X, sz.cy);
	m_rcItem.OffsetRect(ptPos);
	m_dwFlags = dwFlags;
	return sz;
}

void UIStickerElement::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (m_pResouce->IsMouseSelection())
	{
		CPoint ptSelectionStart = m_pResouce->GetSelectionStartPoint();

		if (abs(ptSelectionStart.x - point.x) <= 1 && abs(ptSelectionStart.y - point.y) <= 1)
		{
			if (m_pChatItem->IsFailedMsg() && IsEnableRetryButton())
			{	
				if (m_rcReSendImg.PtInRect(point))
				{
					CChatModel *pChatModel = m_pChatMainView->GetChatModel();
					if (!m_pChatItem->IsGroupUserChat()
						&&pChatModel->CheckSessionCreateStatus(SESSION_SUCCESS)
						&& pChatModel->GetOfflineUserCount() == 0)
					{
						m_pResouce->ResendChatItem(m_pChatItem);
					}
				}
			}
		}
	}
}

BOOL UIStickerElement::OnMouseMove( UINT nFlags, CPoint point )
{
	int nCursor = CURSOR_DEFAULT;
	BOOL bHandled = UIElement::OnMouseMove(nFlags, point);
	if(bHandled) 
	{
		return bHandled;
	}
	if (m_rcReSendImg.PtInRect(point) && m_pChatItem->IsFailedMsg() && IsEnableRetryButton())
	{
		bHandled = TRUE;
		CChatModel *pChatModel = m_pChatMainView->GetChatModel();
		if (!m_pChatItem->IsGroupUserChat()
			&&pChatModel->CheckSessionCreateStatus(SESSION_SUCCESS)
			&& pChatModel->GetOfflineUserCount() == 0)
		{
			nCursor = CURSOR_HAND;
		}
	}
	/*else
	{
		m_pResouce->SetCursor(CURSOR_DEFAULT);
	}*/
	if (MK_LBUTTON == nFlags && m_pResouce->IsMouseSelection() && 
		CHAT_PLAIN == m_pResouce->GetChatDisplayType())
	{
		CPoint ptStart = m_pResouce->GetSelectionStartPoint();
		CPoint ptEnd = point;

		PlainNormalizePoint(ptStart, ptEnd);
		_SetNameSlectedItem(ptStart, ptEnd, FALSE);
		_SetTimeSlectedItem(ptStart, ptEnd, FALSE);
		CRect rc(ptStart, ptEnd);
		rc.NormalizeRect();
		if(rc.PtInRect(m_rcSticker.TopLeft()) && rc.PtInRect(m_rcSticker.BottomRight()) ||
			(rc.top < m_rcSticker.top && rc.bottom > m_rcSticker.bottom))
		{
		   CChatStickerItem* pStickerItem = dynamic_cast<CChatStickerItem*>(m_pChatItem);
		   if(pStickerItem)
		   {
			   pStickerItem->m_bSelected = TRUE;
		   }
		}
		//m_pResouce->InvalidateElement(this, FALSE);

	}

	m_pResouce->SetCursor(nCursor);

	return bHandled;
}

void UIStickerElement::OnLButtonDown( UINT nFlags, CPoint point )
{
	CChatStickerItem* pStickerItem = dynamic_cast<CChatStickerItem*>(m_pChatItem);
	if(pStickerItem)
	{
		pStickerItem->m_bSelected = FALSE;
	}
	ResetSelectRange();
	UIElement::OnLButtonDown(nFlags, point);
}
